package info.kamino.Addressbook;

import javax.swing.*;

/**
 * This class implements the components all AddressbookDialogs like AddressbookNew or
 * AddressbookEdit use together 
 * @author Tobias Hergenroether
 * @version 0.1 *
 */
public class AddressbookDialog extends JFrame
{
  protected JTextField name;
  protected JTextField surname;
  protected JTextField street;
  protected JTextField zip;
  protected JTextField city;
  protected JTextField telephone;
  protected JTextField mobil;
  protected JTextField email;
  protected JTextField url;
  
  /**
   * This is the constructor, which creates the frame which will be customized by the
   * inherited classes
   * @param String
   * @throws nothing
   * @return void
   */
  public AddressbookDialog(String inputTitle){
    super(inputTitle);
    
    initMemberVariables();
  }
  
  /**
   * The method initMemberVariables() initializes all variables of this class
   * @param void
   * @throws nothing
   * @return void 
   */
  private void initMemberVariables(){
    
    name = new JTextField(20);
    name.setToolTipText("Enter the name of the contact. This field is mandatory!");
    
    surname = new JTextField(20);
    surname.setToolTipText("Enter the surname of the contact. This field is mandatory!");
    
    street = new JTextField(20);
    street.setToolTipText("Enter the street the contact is living");
    
    zip = new JTextField(20);
    zip.setToolTipText("Enter the zip code of the address the contact is living");
    
    city = new JTextField(20);
    city.setToolTipText("Enter the city the contact is living");
    
    telephone = new JTextField(20);
    telephone.setToolTipText("Enter the telephone number of the contact");
    
    mobil = new JTextField(20);
    mobil.setToolTipText("Enter the cellphone number of the contact");
    
    email = new JTextField(20);
    email.setToolTipText("Enter the email address of the contact");
    
    url = new JTextField(20);
    url.setToolTipText("Enter the URL of the contact");
    
  }
}
