package info.kamino.Addressbook;

import java.util.*;

/**
 * Thie class is a wrapper around a Hashtable to implement a
 * Model-View-Controller architecture
 * @author Tobias Hergenroether
 * @version 0.1
 */
public class AddressbookList
{
  static Hashtable liste;
  
  /**
   * The constructor initializes the Hashtable
   * @param void
   * @throws nothing
   * @return void
   */
  AddressbookList(){
    liste = new Hashtable(10, 0.75F);
  }
  
  /**
   * The Method add() adds an Object to the Hashtable by the given key
   * @param (String) inputKey
   * @param (Object) inputObject
   * @throws nothing
   * @return boolean
   */
  static boolean add(String inputKey, Object inputObject){
    System.out.println("Adding entry by given key");
    
    int i = 1;
    String testKey = inputKey;
    
    // Checking whether given key is unique
    // If not putting a number at the end of the key until it is unique
    while(liste.containsKey(testKey)){
      testKey = "" + inputKey + i++;
    }
    
    // Object got added
    if ( liste.put(testKey, inputObject) == inputObject ){
      return false;
    }else{
      return true;
    }
  }
  
  /**
   * The method remove() removes an Object from the Hashtable by given key
   * @param (String) inputKey
   * @param (Object) inputObject
   * @throws nothing
   * @return boolean
   */
  static boolean remove(String inputKey){
    System.out.println("Removing Entry by given key");
    
    if (liste.containsKey(inputKey) == true){
      liste.remove(inputKey);
      return true;
    }else{
      return false;
    }
  }
  
  /**
   * The method get() returns the Object, which matchs the given key
   * @param (String) inputKey
   * @throws nothing
   * @return AddressbookEntry
   */
  static AddressbookEntry get(String inputKey){
    System.out.println("Getting Addressbook entry (AdressbookList)");
    
    if (liste.containsKey(inputKey)){
      return (AddressbookEntry) liste.get(inputKey);
    }else{
      return null;
    }
  }
  
  /**
   * The method getKeys() returns all keys of the Hashtable
   * @param void
   * @throws nothing
   * @return Object[]
   */
  static Object[] getKeys(){
    System.out.println("Getting all keys (AddressbookList)");
    
    Set data = liste.keySet();
    String[] keys = new String[data.size()];
    
    int i = 0;
    Iterator iData = data.iterator();
    while (iData.hasNext()){
      keys[i++] = (String) iData.next();
    }
    
    return keys;
  }
}
