package info.kamino.Addressbook;

import java.awt.*;
import javax.swing.*;

/**
 * This class implements the splash window of JavAddressbook during start
 * @author Tobias Hergenroether
 * @version 0.1
 */
public class AddressbookSplash extends JWindow
{
  private JProgressBar loadingStatus;
  private JLabel headline;
  private JLabel loadingModule;
  
  /**
   * The constructor initializes the member variables and places the components
   * on the GUI
   * @param void
   * @throws nothing
   * @return void
   */
  public AddressbookSplash(){
    super();
    setSize(350, 240);
    setLocation(195, 220);
    
    initMemberVariables();
    
    placeComponents();
  }
  
  /**
   * The method initMemberVariables() initializes the member variables
   * @param void
   * @throws nothing
   * @return void
   */
  private void initMemberVariables(){
    loadingStatus = new JProgressBar(0, 100);
    headline = new JLabel("Starting JavAddressbook v0.1...");
    loadingModule = new JLabel();
  }
  
  /**
   * The method placeComponents() places the components on the GUI
   * @param void
   * @throws nothing
   * @return void
   */
  private void placeComponents(){
    
    JPanel pane = new JPanel();
    pane.setLayout(new BorderLayout());
    
    pane.add("North", headline);
    
    loadingModule.setLabelFor(loadingStatus);
    loadingModule.setText("Starting...");
    pane.add("Center", loadingModule);
    
    loadingStatus.setBounds(20, 150, 310, 30);
    loadingStatus.setStringPainted(true);
    pane.add("South", loadingStatus);

    setContentPane(pane);
  }

  /**
   * The method setProgress() manipulates the value of the JProgressBar
   * @param int
   * @throws nothing
   * @return void
   */
  public void setProgress(int inputProgress){
    loadingStatus.setValue(inputProgress);
  }
  
  /**
   * The method setLoadingModule() changes the JLabel text, which informs about
   * which module is started now.
   * @param String
   * @throws nothing
   * @return void
   */
  public void setLoadingModule(String inputModule){
    loadingModule.setText(inputModule);
  }
}
